import { world } from '@minecraft/server'
//Thx Gamerelk for helping me with this script!


world.afterEvents.itemUse.subscribe(event => {

  const player = event.source
  const velocity = player.getVelocity()
  const horizontalStrength = 2.82
  const verticalStrength = 0.35


  if (event.itemStack.typeId == 'parkour:parkour_gloves') {

    const underBar = world.getDimension('overworld')
    if (underBar.getBlock({ x: player.location.x, y: player.location.y + 1, z: player.location.z }).typeId === "parkour:bar" || underBar.getBlock({ x: player.location.x, y: player.location.y + 2, z: player.location.z }).typeId === "parkour:bar") {
      player.applyKnockback(velocity.x, velocity.z, horizontalStrength, verticalStrength)
      player.runCommandAsync('playsound item.trident.throw @s ~ ~ ~ 100 2.1')
      player.runCommandAsync('effect @s speed 1 1')
      player.runCommandAsync('title @s actionbar You §bSwung On A Bar!')
    }
  }
})