
import { world, system } from '@minecraft/server'
//Thx Gamerelk for helping me with this script!

// The Ability Counter
var AbilityCounter = 1

// World Event: Player Join After Event
world.afterEvents.playerJoin.subscribe(() => {

    // System, Runs A Delay Of 10 Ticks
    system.runTimeout(() => {
        for (const player of world.getAllPlayers()) {
            player.runCommandAsync('say test')
        }
    }, 2)
})

// System, Runs Every 10 Ticks (Half Of 1 Second)
system.runInterval(() => {

    // Gets All Players In The World As The Constant "player"
    for (const player of world.getAllPlayers()) {

        // Players Location
        const playerLocation = {
            x: player.location.x,
            y: player.location.y,
            z: player.location.z
        }

        const velocity = player.getVelocity()
        const horizontalStrength = 1.52
        const verticalStrength = 0.39

        // Block Location At The Lower Part Of The Player
        const BlockArea = world.getDimension('overworld').getBlock({ x: playerLocation.x, y: playerLocation.y, z: playerLocation.z })

        // Block Location At The Higher Part Of The Player
        const BlockArea2 = world.getDimension('overworld').getBlock({ x: playerLocation.x, y: playerLocation.y + 1, z: playerLocation.z })

        if (player.isJumping && player.isSneaking && !player.isOnGround && BlockArea.typeId === "minecraft:air" && BlockArea2.typeId === "minecraft:air") {
            if (AbilityCounter === 1) {
                player.applyKnockback(velocity.x, velocity.z, horizontalStrength, verticalStrength)
                player.runCommandAsync('playsound mob.enderdragon.flap @a ~ ~ ~ 10 2.3')
                player.runCommandAsync('title @s actionbar You §bDashed!')
                AbilityCounter = 0
            }
        }

        if (player.isOnGround) {
            AbilityCounter = 1
        }
    }
}, 2)