import { world, system } from '@minecraft/server'

// The Ability Counter
var AbilityCounter = 1

// World Event: Player Join After Event
world.afterEvents.playerJoin.subscribe(() => {

    // System, Runs A Delay Of 10 Ticks
    system.runTimeout(() => {
        for (const player of world.getAllPlayers()) {
            player.runCommandAsync('say test')
        }
    }, 2)
})

// System, Runs Every 10 Ticks (Half Of 1 Second)
system.runInterval(() => {

    // Gets All Players In The World As The Constant "player"
    for (const player of world.getAllPlayers()) {




        const Block = world.getDimension('overworld').getBlock({ x: player.location.x + 1, y: player.location.y, z: player.location.z }).isSolid()
        const Block2 = world.getDimension('overworld').getBlock({ x: player.location.x - 1, y: player.location.y, z: player.location.z }).isSolid()
        const Block3 = world.getDimension('overworld').getBlock({ x: player.location.x, y: player.location.y, z: player.location.z + 1 }).isSolid()
        const Block4 = world.getDimension('overworld').getBlock({ x: player.location.x, y: player.location.y, z: player.location.z - 1 }).isSolid()


        world.afterEvents.itemUse.subscribe(event => {
            const velocity = player.getVelocity()
            const horizontalStrength = 0
            const verticalStrength = 0.95



            if (event.itemStack.typeId == 'parkour:parkour_gloves') {
                if (player.isSneaking && !player.isOnGround) {
                    if (Block === true || Block2 === true || Block3 === true || Block4 === true && player.isSneaking && !player.isOnGround) {
                        if (AbilityCounter === 1) {
                            player.applyKnockback(velocity.x, velocity.z, horizontalStrength, verticalStrength)
                            player.runCommandAsync('playsound damage.fallsmall @s ~ ~ ~ 100 1.2')
                            player.runCommandAsync('title @s actionbar You §bLedge Grabbed!')
                            AbilityCounter = 0
                        }
                    }
                }
            }
        }
        )



        if (player.isOnGround) {
            AbilityCounter = 1
        }
    }
}, 2)